<!--Chris McCue-->
<!--doctor-subpage2.php is the main page for the pill/appointment manager with all the controls and lists-->
<!--Modification History-->
<!--Revision 1:  11/24/2014-->

<!--<!DOCTYPE html>-->
<!--<html>-->
<!--<head>-->
<!--<title>Pill-Appointment Manager</title>-->
    <style>
        #header {
            background-color:black;
            color:black;
            width:520px;
            text-align:center;
            padding:5px;
			line-height:16px;
			font-size:14px;
        }        

        #nav {
            line-height:16px;
            background-color:#eeeeee;
            height:420px;
            width:260px;
            float:left;
            padding:5px;	 
            font-size:14px; 					
        }

        #section {
            line-height:16px;    
            width:260px;
            height:420px;
            float:left;
            padding:5px;	
			font-size:14px;	
        }    
    
        #footer {
            background-color:black;
            color:white;
            clear:both;
            width:520px;
            text-align:center;
            padding:5px;	 	
			line-height:16px;
			font-size:14px;
        }
    </style>

    <script src="http://ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js"></script>
	
	<script>
		var globalPatient;
	
		//converts form data into appointment name string
		function createDateStr(m, d, y, t, sign){
		
			//pads date number to this format:  MM, DD, etc.
			function addZero(nStr){
		
				var n = Number(nStr);
				return n < 10 ? '0' + n : '' + n;
			}

			//split time string into hours and minutes
			var tArray = t.split(':');
			var tNum = Number(tArray[0]);			
			
			//military time adjustments
			if((tNum == 12) && (sign == 'a.m.')) tNum = 0;
			else if((tNum == 12) && (sign == 'p.m.')) tNum = 12;
			else if(sign == 'p.m.') tNum += 12;
			
			return addZero(m)+ ":" + addZero(d) + ":" + y + "-" + 
			addZero(tNum) + ":" + addZero(tArray[1]);
		}			
	</script>
    <script>

        $(document).ready(function(){

            var statusStr;
			
			//deletes appointment from appointment list and database
            $("#deleteApptButton").click(function(){
			
                $("#deleteApptButton").prop("disabled", true);
                $.post("apptdelete.php",{apptDeleteToForm:$("#appointmentList").val(), patientToForm: globalPatient},function(data,status){document.getElementById("statusMessage").innerHTML = data;});
                $("#appointmentList option:selected").remove();     
                $("#deleteApptButton").prop("disabled", false);
            });

			//deletes pill schedule from pill schedule list and database
            $("#deletePillButton").click(function(){
			
                $("#deletePillButton").prop("disabled", true);
                $.post("pilldelete.php",{pillDeleteToForm:$("#pillSchedulesList").val(), patientToForm: globalPatient},function(data,status){document.getElementById("statusMessage").innerHTML = data;});
				$("#pillSchedulesList option:selected").remove();     
                $("#deletePillButton").prop("disabled", false);
            });
        });
		
		//if input is valid, adds appointment to database and appointment list
		function addApptClick(){

			var breakFromFunct = 0;
			
			//create appointment name
			var compareDtStr = createDateStr($("#apptMonthList").val(), $("#apptDayList").val(), $("#apptYearList").val(), $("#apptTimeList").val(), $("#apptTimeAmOrPmList").val());
			
			//disable button for debounce
			$("#addApptButton").prop("disabled", true);
			
			//compare current appointment to appointment list for duplicates		
			$("#appointmentList > option").each(function() {
                
				if(this.value == compareDtStr){
				
					//duplicate appointment message
				    document.getElementById("statusMessage").innerHTML = "An appointment is already scheduled at the same time.";
					$("#addApptButton").prop("disabled", false);
					breakFromFunct = 1;
				}
            });
			
			//if not a duplicate appointment
			if(breakFromFunct == 0){
    	
				var apptUpdateOptionStr;
				var apptUpdateStatus;  
				
				//send data/get data back from "apptadd.php"
				var request = $.post("apptadd.php",
									{
										patientToForm: globalPatient,
   	                                    apptStartYearToForm:$("#apptYearList").val(), 
                                        apptStartMonthToForm:$("#apptMonthList").val(), 
                                        apptStartDayToForm:$("#apptDayList").val(), 
						                apptStartTimeToForm:$("#apptTimeList").val(), 
                                        apptStartSignToForm:$("#apptTimeAmOrPmList").val()
									},
									function(json){		
									
										document.getElementById("statusMessage").innerHTML = json.apptReturnMessage;                           
										apptUpdateOptionStr = json.updateApptList;                                               
										apptUpdateStatus = json.successApptStatus;						   
		
										if(apptUpdateStatus == '1'){
										
											setTimeout(function(){
										
												var option = document.createElement("option");
												option.text = apptUpdateOptionStr;
												option.var = option.text;
												appointmentList.add(option);                    
											}, 300);
										}						   
									},
									"json");  
									
				$("#addApptButton").prop("disabled", false);         
			}        
		}

		//add pill schedule to pill schedule list and database
		function addPillClick(){

			var breakFromFunct = 0;
		    var compareValue = document.getElementById("pillText").value;
			
			//disable for debounce control
			$("#addPillButton").prop("disabled", true);
			
			//check to make sure is not a duplicate		
			$("#pillSchedulesList > option").each(function() {
                
				if(this.value == compareValue){
				
					//duplicate message
				    document.getElementById("statusMessage").innerHTML = "A pill schedule with this name already exists.";
					$("#addPillButton").prop("disabled", false);
					breakFromFunct = 1;
				}
            });
			
			//if not duplicate
			if(breakFromFunct == 0){
		
				var apptUpdateOptionStr;
				var apptUpdateStatus;

				//send and receive data from "pilladd.php"		
				var request = $.post("pilladd.php",
									{		
										patientToForm: globalPatient,										
										pillStartYearEntered:$("#startYearList").val(), 
										pillStartMonthEntered:$("#startMonthList").val(), 
										pillStartDayEntered:$("#startDayList").val(), 
										pillNameEntered:$("#pillText").val(), 
										pillFrequencyEntered:$("#frequencyTimeList").val(),
										pillDosageEntered:$("#dosageList").val(), 
										pillEndTimeEntered:$("#endTimeList").val(), 
										pillEndSignEntered:$("#endTimeAmOrPmList").val(), 
										pillStartTimeEntered:$("#startTimeList").val(), 
										pillStartSignEntered:$("#startTimeAmOrPmList").val(),
										pillDurationEntered:$("#durationDateList").val()   	                                    
									},
									function(json){		
									
										document.getElementById("statusMessage").innerHTML = json.pillReturnMessage;                           
										pillUpdateOptionStr = json.updatePillList;                                               
										pillUpdateStatus = json.successPillStatus;						   
		
										if(pillUpdateStatus == '1'){
										
											setTimeout(function(){
										
												var option = document.createElement("option");
												option.text = pillUpdateOptionStr;
												option.var = option.text;
												pillSchedulesList.add(option);												                    
											}, 300);
										}																				
									},
									"json");  
									
				$("#addPillButton").prop("disabled", false);      
			}           
		}		
		
		//fill patient appointment list		
		function initialApptFill(){
		
			//for patient, get appointment data from "drmgrapptfill.php"
			var request = $.post("drmgrapptfill.php",{
				patientToForm: globalPatient	
				//patientToForm:$("#nameList").val() 
				}, 

				function(json){			
                        var parsed = json;
						for(var i in parsed){
						    var option = document.createElement("option");
                            option.text = json[i].day + "-" + json[i].time;
                            option.var = option.text;
                            appointmentList.add(option);                    
                     	}
    				    document.getElementById("statusMessage").innerHTML = "Welcome to the pill and appointment manager.";
				} ,"json");                                  
        }
		
		//fill patient pill schedule list
		function initialPillFill(){

			//for patient, get pill schedule data from "drmgrpillfill.php"	
            var request = $.post("drmgrpillfill.php",{
   	            patientToForm: globalPatient					
                }, 

    			function(json){			
 					for(var i in json){
					    var option = document.createElement("option");
                        option.text = json[i];
                        option.var = option.text;
                        pillSchedulesList.add(option);                    
                   	}
    			    document.getElementById("statusMessage").innerHTML = "Welcome to the pill and appointment manager.";
				} ,"json");                                  
        }		
    </script>
    <script>        
        /**********************************************************
        ***********************************************************
        **@brief- fillTimes fills in a dropdown list with times
        **  	  in 30 minute increments.
        **@params timeList- dropdown list to add times to
        ***********************************************************
        **********************************************************/
        function fillTimes(timeList) {

            var i;

            for(i = 0; i < 12; i++){

                //add 12:00, 1:00, ... to list
                var option = document.createElement("option");
                if(i == 0) option.text = "12:00";
                else option.text = i.toString() + ":00";
                option.value = option.text;
                timeList.add(option);
        
                //add 12:30, 1:30, ... to list
                var option = document.createElement("option");
                if(i == 0) option.text = "12:30";        
                else option.text = i.toString() + ":30";
                option.value = option.text;
                timeList.add(option);
            }
        }
 
        /**********************************************************
        ***********************************************************
        **@brief- fillNumLists fills in a dropdown list with numbers.
        **@params numList- dropdown list to add numbers to
        **@unitSpecifier- units to display in dropdown list
        **@maxNumber- maximum number numbers go to
        ***********************************************************
        **********************************************************/
        function fillNumList(numList, unitSpecifier, maxNumber) {

            var numListIndex;

            for(numListIndex = 1; numListIndex <= maxNumber; numListIndex++){

                var option = document.createElement("option");
                option.text = numListIndex.toString() + unitSpecifier;
                option.value = option.text;
                numList.add(option);
            }
         }

		//hides everything except for the select patient header 
        function hideMain(){

            $('#footer').hide();    
            $('#nav').hide();    
            $('#section').hide();             
        } 

		//show the rest of the page and fill it with patient data
        function showMain(){
		
			globalPatient = document.getElementById("nameList").value;
			
			//if no patient selected, do nothing
			if(globalPatient == "") return;
			
            $('#footer').show();    
            $('#nav').show();    
            $('#section').show(); 
			
			//disable patient select button
			$("#selectPatientButton").prop("disabled", true);  
			
			initialApptFill();     
            initialPillFill();			
			
			//wait a little bit before displaying status message
			setTimeout(function(){
			
				document.getElementById("statusMessage").innerHTML = "Patient " + tempPatient + " has been selected.";            							
			}, 300);
			
			//disable patient select list	
			$('#nameList').prop("disabled", true);                          
        } 
    </script>
</head>

<!--<body onload="hideMain()">-->
    <script>
	    document.getElementsByTagName('body')[0].onload = hideMain();
	</script>
	
    <?php	
        //include the pill manager related functions
        include 'medicine-includes.php';

        //call this to check if anyone is logged in.
        session_start();
        if(!isset($_SESSION['user'])) {
            echo 'Error: not logged in. Log in <a href="index.php">here</a>.<br>';
        }

        //call getPatients to retrieve an array containing the patients for the user in session
        $username = $_SESSION['user'];
        $patients = getPatients($username);                          
    ?> 
        
    <div id="header">
		<select id="nameList">            
            <?php
                foreach($patients as $patient){
                    echo '<option> ' . $patient . ' </option>';
                }
            ?>  
        </select> 
		<br><br>	
        <button type="button" id = "selectPatientButton" onclick="showMain()">Select Patient</button>
        <hr>       

    </div>

    <!--*******************************************-->    
    <!--*************PILLS*************************-->
    <!--*******************************************-->        
    <div id="nav">        

        <!--*************************************************-->             
        <!--**************ADD PILL SCHEDULE.*****************-->   
        <!--*************************************************-->               
            
            <b>Pills</b><br>
            
            Medication: &nbsp &nbsp
            
            <input type = "text" id = "pillText"><br>
            
            Dosage(pills): 
            
            <select id="dosageList">
                <script>
                    fillNumList(document.getElementById("dosageList"),"", 6);
                </script>
            </select><br><br>
            
            <!--*************************************************--> 
            
            <b>Date</b><br>  
  
            Start: &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp

            <select id="startMonthList">
                <script>
                    fillNumList(document.getElementById("startMonthList"),"",12);
                </script>
            </select>
        
            <select id="startDayList">
                <script>
                    fillNumList(document.getElementById("startDayList"),"",31);
                </script>
            </select>

            <select id="startYearList">
                <?php 
                    $nextYear = date("Y");
                    echo '<option value='.date("Y").'>'.date("Y").'</option>';
                    $nextYear += 1;
                    echo '<option value='.$nextYear.'>'.$nextYear.'</option>';                 
                ?>                       
            </select><br>    
            
            Duration: &nbsp &nbsp &nbsp &nbsp 
            <select id="durationDateList">
                <script>
                    fillNumList(document.getElementById("durationDateList")," days",20);
                </script>                
            </select><br><br>

            <!--*************************************************--> 
            
            <b>Time</b><br>
    
            Start: &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp

            <select id="startTimeList">  
                <script>
                    fillTimes(document.getElementById("startTimeList"));
                </script>
            </select>   

            <select id="startTimeAmOrPmList">  
                <option value="a.m.">a.m.</option>
                <option value="p.m.">p.m.</option>
            </select><br>

            Times/day: &nbsp &nbsp  
            <select id="frequencyTimeList">  
                <script>
                    fillNumList(document.getElementById("frequencyTimeList"),"",10);
                </script>
            </select><br>

            End: &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp

            <select id="endTimeList">  
                <script>
                    fillTimes(document.getElementById("endTimeList"));
                </script>
            </select>

            <select id="endTimeAmOrPmList">  
                <option value = 'a.m.'>a.m.</option>
                <option value = 'p.m.'>p.m.</option>
            </select><br><br>

            <!--*************************************************--> 
            
            <button id="addPillButton" onclick="addPillClick();">Add Pill Schedule</button><hr>


        <!--*************************************************-->             
        <!--**************DELETE PILL SCHEDULE.**************-->   
        <!--*************************************************-->             
 
            <b>Pill Schedules</b><br><br>
            <select id="pillSchedulesList" size = 3>
            </select><br><br>
            <button id="deletePillButton">Delete Pill Schedule</button>      
    </div>

    <!--*******************************************-->    
    <!--*********APPOINTMENTS.*********************-->
    <!--*******************************************-->  
    <div id="section">
        
        <!--*************************************************-->             
        <!--**************ADD APPOINTMENT.*******************-->   
        <!--*************************************************--> 
            
            <b>Schedule</b><br><br>

            Date: &nbsp

            <select id="apptMonthList" name="apptStartMonthEntered">
                <script>
                    fillNumList(document.getElementById("apptMonthList"),"",12);
                </script>
            </select>

            <select id="apptDayList" name="apptStartDayEntered">
                <script>
                    fillNumList(document.getElementById("apptDayList"),"",31);
                </script>
            </select>

            <select id="apptYearList" name="apptStartYearEntered">
                <?php 
                    $apptNextYear = date("Y");
                    echo '<option value='.date("Y").'>'.date("Y").'</option>';
                    $apptNextYear += 1;
                    echo '<option value='.$apptNextYear.'>'.$apptNextYear.'</option>';                 
                ?>                       
            </select><br><br>
    
            Start: &nbsp

            <select id="apptTimeList" name="apptStartTimeEntered">  
                <script>
                    fillTimes(document.getElementById("apptTimeList"));
                </script>
            </select>   

            <select id="apptTimeAmOrPmList" name="apptStartSignEntered">  
                <option value = 'a.m.'>a.m.</option>
                <option value = 'p.m.'>p.m.</option>
            </select><br><br>
            
            <button id="addApptButton" onclick="addApptClick();" >Add Appointment</button>
            <!--<br><br><br><br><br><br><br><br><br><br><br>-->
			<hr>

        <!--*************************************************-->             
        <!--**************DELETE APPOINTMENT.****************-->   
        <!--*************************************************--> 

			<b>Appointments</b><br><br>

            <select id="appointmentList" name="apptToDelete" size=11>                
            </select><br><br>

            <button id="deleteApptButton">Delete Appointment</button>
            
    </div>
    <div id="footer">  
        <p id="statusMessage">status message</p>          
    </div> 
        
<!--</body>-->
<!--</html>-->
