/*
Author: Ethan Pitts
Date: 9/16/2014
Last Edited: 11/13/2014

This file handles the navigation between different 
modules of the Online Health Monitoring System.
This file is dependant on jQuery.
*/

window.onload = function() {
	var menu = new MenuBar(1);
	console.log("loaded menu");

	$('.menu-bar .item1').click(function() { menu.navigateTo(1) });
	$('.menu-bar .item2').click(function() { menu.navigateTo(2) });
	$('.menu-bar .item3').click(function() { menu.navigateTo(3) });
};

function ViewWindow()
{
	// This function loads a PHP file into the view window.
	this.loadPhp = function(file)
	{
		$.ajax(file + ".php")
			.done(function(data) {
				$('#subpage-viewer').html(data);
			}
		);
	}
}

function MenuBar(item)
{
	// phpIsDoctor is defined in the main PHP file, user.php.
	this.isDoctor = phpIsDoctor();
	this.viewWindow = new ViewWindow();

	// This function adds a class to the chosen item
	// to make the background a blue-grey.
	this.highlightItem = function(itemNum)
	{
		$('.menu-bar .active').removeClass('active');
		$('.menu-bar .item' + itemNum).addClass('active');
	}

	// This function highlights the correct item, and tells the 
	// view window to load the correct PHP file. 
	this.navigateTo = function(subpageNum)
	{
		this.highlightItem(subpageNum);

		if (this.isDoctor)
			this.viewWindow.loadPhp("partials/doctor-subpage" + subpageNum);
		else
			this.viewWindow.loadPhp("partials/patient-subpage" + subpageNum);
	}

	// If the user is a doctor, load the load the doctor's menu, 
	// otherwise, load the patient's menu.
	if (this.isDoctor)
		$('.doctor-menu').removeClass('hidden');
	else
		$('.patient-menu').removeClass('hidden');

	// Load the initial screen
	this.navigateTo(item);
}